// Variables Globales del Interfaz de Usuario/*{{{*/

var contabilidad = parent.parent.contabilidad;
var asientosSesion = new Array(); //Lista de Asientos creados/modificados en la sesin
var asientoSeleccionado;
var maxApunte = 0;
var estadoIU = "Espera";

var observerCuenta = {
  getSupportedFlavours : function () {
    var flavours = new FlavourSet();
    flavours.appendFlavour("cuenta");
    return flavours;
  },
  onDragStart: function (evt, transferData, action){
    //Borramos la cuenta
    evt.target.setAttribute("value", "Arrastra Cuenta");
    evt.target.cuenta = null;
  },
  onDrop: function (evt,dropdata,session){
    //Solo aceptamos cuentas finales
    var cuentaSeleccionada = contabilidad.verCuentaPorId(dropdata.data);
    if (cuentaSeleccionada.fin){
      evt.target.setAttribute("value", cuentaSeleccionada.nombre);
      evt.target.setAttribute("tooltiptext", cuentaSeleccionada.verNombreCompleto());
      evt.target.idCuenta = dropdata.data;
    }
  },
  onDragOver: function (evt, flav, dragSession){
    //Esta funcin hace falta aunque no haga nada.
  }
};  //Ojo a las , y al ;
/*}}}*/

function iniciar(){/*{{{*/
//Inicializamos las listas desplegables
  cargarAsientosPredefinidos(document.getElementById("menupopupPredefinidos"));
  cargarTiposAsiento(document.getElementById("menupopupBuscarTipo"));
  cargarTiposAsiento(document.getElementById("menupopupTipo"));
}/*}}}*/

function cargarAsientosPredefinidos(menupopupPredefinidos){/*{{{*/
  //Borramos la lista
  while (menupopupPredefinidos.hasChildNodes())
    menupopupPredefinidos.removeChild(menupopupPredefinidos.firstChild);
  for (var i=0; i< contabilidad.predefinido.length; i++){
    var predefinido = document.createElement("menuitem");
    predefinido.setAttribute("label", contabilidad.predefinido[i].nombre);
    predefinido.setAttribute("oncommand", "cargarPredefinido(contabilidad.predefinido["+i+"])");
    menupopupPredefinidos.appendChild(predefinido);
  }
}/*}}}*/

function cargarTiposAsiento(menupopup){/*{{{*/
  //Borramos la lista
  while (menupopup.hasChildNodes())
    menupopup.removeChild(menupopup.firstChild);
  for (var i=0; i< contabilidad.tipoAsiento.length; i++){
    var menuitem = document.createElement("menuitem");
    menuitem.setAttribute("label", contabilidad.tipoAsiento[i].nombre);
    menuitem.tipo = contabilidad.tipoAsiento[i];
    menupopup.appendChild(menuitem);
  }
}/*}}}*/

function botonNuevo(){ //{{{
//Respuesta al botn Nuevo
  cambiarEstado("Insercin");
  borrarCamposAsiento();
} //}}}

function botonEditar(){  //{{{
//Respuesta al botn Editar
  cambiarEstado("Edicin");
}  //}}}

function botonBorrar(){ //{{{
//Respuesta al botn Borrar
  if(confirm("Estas segura/o de que quieres BORRAR este Asiento?")){
    contabilidad.borrarAsiento(asientoSeleccionado);
    contabilidad.modificada = true;
    //parent.parent.autoguardar();  //Guarda una copia de seguridad del fichero
    //Lo quitamos de la lista de Asientos
    if (asientosSesion.length > 0){ //Porque podra estar en la lista del buscador, no de sesin
      var i=0;
      while ((i<asientosSesion.length) && (asientosSesion[i++] != asientoSeleccionado))
	;
      while (i<asientosSesion.length)
	asientosSesion[i - 1] = asientosSesion[i++];
      asientosSesion[i - 1] = null;
      asientosSesion.length--;
    
      //Y actualizamos la lista
      mostrarAsientosSesion();
    }
    else //Si es del buscador, actualizamos la bsqueda
      buscar();
  }
  botonCancelar();
} //}}}

function botonAceptar(){ //{{{
//Respuesta al botn Aceptar
  if(!comprobarAsiento()) return;
  
  //Optamos entre un nuevo asiento o el seleccionado en la lista
  if(estadoIU == "Insercin") asiento = contabilidad.nuevoAsiento();
  else asiento = asientoSeleccionado;
 
  //Modificamos el asiento segn los datos del formulario
  asiento.nombre = document.getElementById("textboxNombre").value;
  asiento.fecha = verFecha(document.getElementById("textboxFecha"));
  asiento.documento = document.getElementById("textboxDocumento").value;
  asiento.prevision =  document.getElementById("checkboxPrevision").checked;
  asiento.notas = document.getElementById("textboxNotas").value;
  asiento.tipo = document.getElementById("menulistTipo").selectedItem.tipo;
  asiento.factura = document.getElementById("textboxNumeroFactura").value;

  //Borramos todos los apuntes para volver a crearlos
  asiento.borrarApuntes(); 
  //Aadimos los apuntes
  for (var i=0; i<maxApunte; i++){
    idLabelApunte = "labelApunte" + i;
    idTextboxApunte = "textboxApunte" + i;
    var idCuenta = document.getElementById(idLabelApunte).idCuenta;
    var importe = document.getElementById(idTextboxApunte).value;
    //Le ponemos los decimales, si no los tiene
    if (importe != ""){
      var temporal = importe.split(".");
      if (temporal.length == 1) importe += ".00";
      else
	if (temporal[1].length == 1) importe += "0";
    }
    if ((idCuenta != null) && (importe != "") && (importe != 0)) {
      var apunte = asiento.nuevoApunte();
      apunte.idCuenta = idCuenta;
      apunte.importe = importe;
    }
  }
 
  //Lo incluimos en la lista de asientos, pero comprobamos que no est
  //se podra duplicar si es un asiento insertado en la sesin que despus se modifica
  for (var i=0; i<asientosSesion.length; i++)
    if (asientosSesion[i] == asiento) break;
  if (i == asientosSesion.length) //Es decir, no hemos roto el bucle.
    asientosSesion[asientosSesion.length] = asiento;
 
  contabilidad.modificada = true;
 
  botonCancelar();
} //}}}

function botonCancelar(){ //{{{
//Respuesta al botn Cancelar
  cambiarEstado("Espera");
  borrarCamposAsiento();
  document.getElementById("textboxCuadre").value = "0";
}  //}}}

function botonMasApuntes(){/*{{{*/
//Crea nuevas lneas de Apuntes
  for (var i=0; i<5; i++)
    crearApunte();
}/*}}}*/

function cambiarEstado(estado){/*{{{*/
//Cambia el estado del Interfaz de Usuario
  estadoIU = estado;
  switch (estado){
    //Modos Pasivos
    case "Espera":
      document.getElementById("botonNuevo").removeAttribute("disabled");
      document.getElementById("botonEditar").setAttribute("disabled", "true");
      document.getElementById("botonBorrar").setAttribute("disabled", "true");
      document.getElementById("menulistPredefinidos").selectedIndex = -1;
      document.getElementById("menulistPredefinidos").setAttribute("disabled","true");
      document.getElementById("botonMasApuntes").setAttribute("disabled","true");
      document.getElementById("botonAceptar").setAttribute("disabled", "true");
      document.getElementById("botonCancelar").setAttribute("disabled", "true");
      document.getElementById("listboxAsientos").removeAttribute("disabled");
      document.getElementById("textboxNombre").setAttribute("disabled","true");
      document.getElementById("textboxFecha").setAttribute("disabled","true");
      document.getElementById("textboxDocumento").setAttribute("disabled","true");
      document.getElementById("checkboxPrevision").setAttribute("disabled","true");
      document.getElementById("textboxNotas").setAttribute("disabled","true");
      document.getElementById("menulistTipo").setAttribute("disabled","true");
      document.getElementById("textboxNumeroFactura").setAttribute("disabled","true");
      document.getElementById("textboxNumeroFactura").value ="";
      //Desactivamos los apuntes
      for (var i=0; i<maxApunte; i++){
  	idTextboxApunte = "textboxApunte" + i;
  	textboxApunte = document.getElementById(idTextboxApunte);
  	textboxApunte.setAttribute("disabled","true");
      }
      break;
    case "Consulta":
      document.getElementById("botonNuevo").removeAttribute("disabled");
      document.getElementById("botonEditar").removeAttribute("disabled");
      document.getElementById("botonBorrar").removeAttribute("disabled");
      document.getElementById("menulistPredefinidos").selectedIndex = -1;
      document.getElementById("menulistPredefinidos").setAttribute("disabled","true");
      document.getElementById("botonAceptar").setAttribute("disabled", "true");
      document.getElementById("botonCancelar").setAttribute("disabled", "true");
      document.getElementById("listboxAsientos").removeAttribute("disabled");
      document.getElementById("textboxNombre").setAttribute("disabled","true");
      document.getElementById("textboxFecha").setAttribute("disabled","true");
      document.getElementById("textboxDocumento").setAttribute("disabled","true");
      document.getElementById("checkboxPrevision").setAttribute("disabled","true");
      document.getElementById("textboxNotas").setAttribute("disabled","true");
      document.getElementById("menulistTipo").setAttribute("disabled","true");
      document.getElementById("textboxNumeroFactura").setAttribute("disabled","true");
      //Desctivamos los apuntes
      for (var i=0; i<maxApunte; i++){
  	idTextboxApunte = "textboxApunte" + i;
  	textboxApunte = document.getElementById(idTextboxApunte);
  	textboxApunte.setAttribute("disabled","true");
      }
      break;

    //Modos Activos
    case "Insercin":
      document.getElementById("menulistPredefinidos").removeAttribute("disabled");
    case "Edicin":
      document.getElementById("botonMasApuntes").removeAttribute("disabled");
      document.getElementById("botonNuevo").setAttribute("disabled","true");
      document.getElementById("botonEditar").setAttribute("disabled", "true");
      document.getElementById("botonBorrar").setAttribute("disabled", "true");
      document.getElementById("botonAceptar").removeAttribute("disabled");
      document.getElementById("botonCancelar").removeAttribute("disabled");
      document.getElementById("listboxAsientos").setAttribute("disabled","true");
      document.getElementById("textboxNombre").removeAttribute("disabled");
      document.getElementById("textboxFecha").removeAttribute("disabled");
      document.getElementById("checkboxPrevision").removeAttribute("disabled");
      document.getElementById("textboxDocumento").removeAttribute("disabled");
      document.getElementById("textboxNotas").removeAttribute("disabled");
      document.getElementById("menulistTipo").removeAttribute("disabled");
      activarDesactivarFactura();
      //Activamos los apuntes
      for (var i=0; i<maxApunte; i++){
  	idTextboxApunte = "textboxApunte" + i;
  	textboxApunte = document.getElementById(idTextboxApunte);
  	textboxApunte.removeAttribute("disabled");
      }
      break;
      
    default:
      alert("El estado " + estado + " es desconocido");
  }
}/*}}}*/

function borrarCamposAsiento(){/*{{{*/
//Borra el contenido de los campos de Asiento
  document.getElementById("textboxNombre").value="";
  document.getElementById("textboxFecha").value="";
  document.getElementById("textboxDocumento").value="";
  document.getElementById("checkboxPrevision").removeAttribute("checked");
  document.getElementById("textboxNotas").value="";
  document.getElementById("menulistTipo").selectedIndex = -1;
  document.getElementById("textboxNumeroFactura").value = "";
  
  borrarApuntes();
  
}/*}}}*/

function crearApunte(){/*{{{*/
//Crea una nueva lnea de Apunte
  var boxApunte = document.createElement("hbox");
  var idBoxApunte = "boxApunte" + maxApunte;
  boxApunte.setAttribute("id", idBoxApunte);
  var labelApunte = document.createElement("label");
  idLabelApunte = "labelApunte" + maxApunte;
  labelApunte.setAttribute("id", idLabelApunte);
  labelApunte.setAttribute("value", "Arrastra Cuenta");
  labelApunte.setAttribute("style","background-color:lightsteelblue; border-style:inset; border-width:1px; min-width:100px; max-width:150px;");
  labelApunte.setAttribute("ondragdrop","nsDragAndDrop.drop(event, observerCuenta);");
  labelApunte.setAttribute("ondragover","nsDragAndDrop.dragOver(event, observerCuenta);");
  var textboxApunte = document.createElement("textbox");
  idTextboxApunte = "textboxApunte" + maxApunte;
  textboxApunte.setAttribute("id", idTextboxApunte);
  textboxApunte.setAttribute("style", "text-align: right;");
  if (estadoIU == "Consulta") textboxApunte.setAttribute("disabled", "true");
  //textboxApunte.setAttribute("value", verCuadre());
  textboxApunte.setAttribute("size", "10");
  valorOnblur = "compruebaImporte(this," + maxApunte + ");";
  textboxApunte.setAttribute("onblur", valorOnblur);

  boxApunte.appendChild(labelApunte);
  boxApunte.appendChild(textboxApunte);
  document.getElementById("boxApuntes").appendChild(boxApunte);
  
  return maxApunte++;
  
}/*}}}*/

function activarDesactivarFactura(){ //{{{
//Activa o desactiva el campo de nmero de factura en funcin del tipo de asiento
  if (document.getElementById("menulistTipo").selectedItem){  //Por si no hubiera ninguno seleccionado
    //var tipo = document.getElementById("menulistTipo").selectedItem.getAttribute("label");
    var tipo = document.getElementById("menulistTipo").selectedItem.tipo;
    if ((estadoIU == "Insercin") || (estadoIU == "Edicin"))
      if (tipo.factura)
	document.getElementById("textboxNumeroFactura").removeAttribute("disabled");
      else {
	document.getElementById("textboxNumeroFactura").value = "";
	document.getElementById("textboxNumeroFactura").setAttribute("disabled","true");
      }
  }
}  //}}}

function comprobarAsiento(){/*{{{*/
//Comprueba la integridad de un asiento antes de su insercin o modificacin
  var textoError = "";
  //Debe tener un nombre
  if (document.getElementById("textboxNombre").value == "") 
    textoError = textoError + "Todo Asiento debe tener un Nombre.\n";
  //Debe tener una fecha
  if (document.getElementById("textboxFecha").value == "")
    textoError = textoError + "Todo Asiento debe tener una Fecha.\n";
  //El ao del asiento debe coincidir con el ao de la contabilidad
  //if (document.getElementById("textboxFecha").value.split("/")[2] != contabilidad.referencia)
    //textoError = textoError + "La fecha del asiento debe ser del mismo ao que la contabilidad.\n"
  //Debe tener, al menos, dos apuntes
  if (maxApunte < 2)
    textoError = textoError + "Todo Asiento debe tener, al menos, dos apuntes.\n";
  //Todas las cuentas deben ser finales (pueden no serlo inicialmente por ser un Predefinido)
  var hayCuentasNoFinales = false;
  for (var i=0; i<maxApunte; i++){
    idLabelApunte = "labelApunte" + i;
    if (document.getElementById(idLabelApunte).cuenta != null)
      if (!document.getElementById(idLabelApunte).cuenta.fin)
	hayCuentasNoFinales = true;
  }
  if (hayCuentasNoFinales)
    textoError = textoError + "Solo se pueden insertar apuntes en cuentas finales.\n";
  //Debe cuadrar
  actualizarCuadre();
  if (document.getElementById("textboxCuadre").value != 0)
    textoError = textoError + "Todo Asiento debe cuadrar. Este descuadra por " + document.getElementById("textboxCuadre").value + "\n";
  //Debe haber algn tipo seleccionado
  if (document.getElementById("menulistTipo").selectedItem == null)
    textoError = textoError + "Todo Asiento debe tener un tipo.\n";
  else
    //Si es asiento del tipo factura
    if ((document.getElementById("menulistTipo").selectedItem.tipo.factura) && (document.getElementById("textboxNumeroFactura").value == ""))
      textoError = textoError + "Los Asientos de Tipo Factura deben tener un Nmero de Factura.\n";
  
  if (textoError != ""){
    alert(textoError);
    return false;
  }
  else return true;
}/*}}}*/

function mostrarAsientosSesion(){/*{{{*/
//Muestra en la Lista de Asientos los asientos creados/modificados en la sesin actual
  borrarListaAsientos();
  for (var i=0; i<asientosSesion.length; i++)
    ponerEnListaAsientos(asientosSesion[i]);
}/*}}}*/

function borrarApuntes(){/*{{{*/ 
//Borra los apuntes
    boxApuntes = document.getElementById("boxApuntes");
    while(boxApuntes.childNodes.length)
      boxApuntes.removeChild(boxApuntes.childNodes.item(0));
    maxApunte = 0;
}/*}}}*/

function ponerEnListaAsientos(asiento){ //{{{
//Aade un asiento a la Lista de Asientos
  var listaAsientos = document.getElementById("listboxAsientos");
  var item = document.createElement("listitem");
  var itemCellFecha = document.createElement("listcell");
  var itemCellNombre = document.createElement("listcell");
  
  var fecha = asiento.fecha.getDate()+"/"+(asiento.fecha.getMonth()+1)+"/"+asiento.fecha.getFullYear();
  itemCellFecha.setAttribute("label",fecha);
  itemCellNombre.setAttribute("label",asiento.nombre);
  
  if(asiento.prevision){
    var hoy = new Date();
    if(hoy < asiento.fecha){
      itemCellNombre.setAttribute("style","color:blue");
      itemCellFecha.setAttribute("style","color:blue");
    }
    else{
      itemCellNombre.setAttribute("style","color:red");
      itemCellFecha.setAttribute("style","color:red"); 
    }
  } 
  //Aadimos las celdas al elemento de la lista
  item.appendChild(itemCellFecha);
  item.appendChild(itemCellNombre);
  
  //Y le aadimos el puntero al propio asiento
  item.asiento = asiento;
  
  listaAsientos.appendChild(item);
}  //}}}

function buscar(){/*{{{*/
//Busca los asientos que coincidan con los criterios indicados
  //Elaboracin de los criterios
  var criterio = new Object();
  criterio.asiento =  document.getElementById("checkboxAsientos").hasAttribute("checked");
  criterio.prevision = document.getElementById("checkboxPrevisiones").hasAttribute("checked");
  criterio.fechaDesde = verFecha(document.getElementById("textboxFechaDesde"));
  criterio.fechaHasta = verFecha(document.getElementById("textboxFechaHasta"));
  criterio.importe = document.getElementById("textboxImporteBuscar").value;
  criterio.tipo = null;
  if (document.getElementById("menulistBuscarTipo").selectedItem)
    criterio.tipo = document.getElementById("menulistBuscarTipo").selectedItem.tipo;
  criterio.idCuenta = null;
  if (document.getElementById("labelCuentaBuscador").idCuenta) criterio.idCuenta = document.getElementById("labelCuentaBuscador").idCuenta;
  
  var arrayAsientos = contabilidad.buscarAsientos(criterio);  //La verdadera funcin buscar
  arrayAsientos.sort(ordenarAsientos);
  //Y ahora los presentamos
  borrarListaAsientos();
  for(var i=0; i<arrayAsientos.length; i++)
    ponerEnListaAsientos(arrayAsientos[i]);
  
}/*}}}*/

function mostrar(){/*{{{*/
//Muestra los datos del asiento seleccionado
  listaAsientos = document.getElementById("listboxAsientos");
  if ((estadoIU == "Espera") || (estadoIU == "Consulta") || (listaAsientos.selectedItem != null)){

    asientoSeleccionado = listaAsientos.selectedItem.asiento;
    document.getElementById("textboxNombre").value = asientoSeleccionado.nombre;
    var fecha = asientoSeleccionado.fecha.getDate()+"/"+(asientoSeleccionado.fecha.getMonth() + 1)+"/"+asientoSeleccionado.fecha.getFullYear();
    document.getElementById("textboxFecha").value = fecha;
    document.getElementById("textboxDocumento").value = asientoSeleccionado.documento;
    document.getElementById("textboxNotas").value = asientoSeleccionado.notas;
    if (asientoSeleccionado.tipo)
      document.getElementById("menulistTipo").selectedItem = document.getElementById("menulistTipo").getElementsByAttribute("label", asientoSeleccionado.tipo.nombre)[0];
    document.getElementById("textboxNumeroFactura").value = asientoSeleccionado.factura;

    if(asientoSeleccionado.prevision) document.getElementById("checkboxPrevision").setAttribute("checked","true");
    else document.getElementById("checkboxPrevision").removeAttribute("checked");
    borrarApuntes(); 
    for(var i=0;i<asientoSeleccionado.apunte.length;i++)
      mostrarApunte(asientoSeleccionado.apunte[i]);    
    actualizarCuadre();
    
    cambiarEstado("Consulta");
  }
}/*}}}*/

function comprobarFecha(campo){ //{{{
//Comprueba que el campo contenga una fecha vlida
  var error = false;
  var fecha = campo.value;
  if (fecha != ""){
    var datosFecha = fecha.split("/");
    if(datosFecha.length == 2){
      var ahora = new Date();
      ano = 1900 + ahora.getYear();
      datosFecha[2] = "" + ano;
      campo.value = campo.value + "/" + ano;
    }
    if(datosFecha.length != 3) error=true;
    else if(datosFecha[0] > 31) error=true;
      else if(datosFecha[1] > 12) error=true;
        else if(datosFecha[2].length != 4) error=true;
  }
  if(error){
    alert("Oye! Esta fecha no es vlida.\nDebe ser del tipo \"dd/mm/aaaa\".");
    campo.value="";
    return error;
  }
} //}}}

function verFecha(textbox){/*{{{*/
//Devuelve la fecha introducida en un textbox
  if (textbox.value != ""){
    var trozoFecha = textbox.value.split("/");
    var mes = trozoFecha[1] - 1;
    fecha = new Date(trozoFecha[2],mes,trozoFecha[0]);
  }
  else fecha = null;
  
  return fecha;
  
}/*}}}*/

function borrarListaAsientos(){/*{{{*/
  var listaAsientos = document.getElementById("listboxAsientos");
  while(listaAsientos.removeItemAt(2));	//Hay que mantener las columnas y los encabezados
}/*}}}*/

function compruebaImporte(textboxImporte, apunte){/*{{{*/
//Comprueba el importe del apunte indicado
  var importe = textboxImporte.value;
  if (importe.split(",").length > 1){
    alert("Ser mejor que quites las comas. Usa el punto");
    return;
  }
  if (isNaN(importe)){
    alert("Ser mejor que pongas un importe correcto");
    return;
  }

  //Actualizamos el cuadre
  actualizarCuadre();
} /*}}}*/

function actualizarCuadre(){/*{{{*/
//Actualiza el textbox de Cuadre
  var saldo = 0;
  //Recorremos todos los apuntes
  for (var i=0; i<maxApunte; i++){
    idLabelApunte = "labelApunte" + i;
    idTextboxApunte = "textboxApunte" + i;
    if (document.getElementById(idLabelApunte).idCuenta != null){
      var tipo = contabilidad.verCuentaPorId(document.getElementById(idLabelApunte).idCuenta).tipo;
      var importe = Math.round(parseFloat(document.getElementById(idTextboxApunte).value) * 100) / 100;
      if ((tipo == "Activo") || (tipo == "Gastos")) saldo = saldo + importe;
      else saldo = saldo - importe;
    }
  }
  var textboxCuadre = document.getElementById("textboxCuadre")
  textboxCuadre.value = Math.round(saldo * 100)/100;
  if(saldo!=0) textboxCuadre.setAttribute("style","text-align: right; color:red");
  else textboxCuadre.setAttribute("style","text-align: right; color:green");

}/*}}}*/

function mostrarApunte(apunte){/*{{{*/
//Crea un apunte y muestra en l sus datos
  indice = crearApunte();
  idLabelApunte = "labelApunte" + indice;
  idTextboxApunte = "textboxApunte" + indice;
  labelApunte = document.getElementById(idLabelApunte);
  textboxApunte = document.getElementById(idTextboxApunte);
  labelApunte.idCuenta = apunte.idCuenta;
  labelApunte.cuenta = contabilidad.verCuentaPorId(apunte.idCuenta);
  labelApunte.value = labelApunte.cuenta.nombre;
  labelApunte.setAttribute("tooltiptext", labelApunte.cuenta.verNombreCompleto());
  textboxApunte.value = apunte.importe;

}/*}}}*/

function cargarPredefinido(predefinido){/*{{{*/
//Crea los apuntes de un asiento predefinido
  //Ponemos el tipo
  document.getElementById("menulistTipo").selectedItem = document.getElementById("menulistTipo").getElementsByAttribute("label", predefinido.tipo.nombre)[0];
  activarDesactivarFactura();
      for (var i=0; i<predefinido.apunte.length; i++){
	var idApunte = crearApunte();
	var idLabelApunte = "labelApunte" + idApunte;
	document.getElementById(idLabelApunte).idCuenta = predefinido.apunte[i].idCuenta;
	document.getElementById(idLabelApunte).setAttribute("value", contabilidad.verCuentaPorId(predefinido.apunte[i].idCuenta).nombre);
	if (predefinido.apunte[i].formula != ""){
	  var idTextboxApunte = "textboxApunte" + idApunte;
	  document.getElementById(idTextboxApunte).setAttribute("style", document.getElementById(idTextboxApunte).getAttribute("style") + ";background-color: grey");
	  document.getElementById(idTextboxApunte).setAttribute("value", "Pend. Clculo");
	  //var formula = "this.value = document.getElementById('textboxApunte' + 0).value;"; //Hay que sustituir los $N
	  //var re = /\$d+/; 
	  var formula = "this.value = Math.round(parseFloat(" + predefinido.apunte[i].formula + ") *100)/100;";
	  //Vamos a hacer una chapuza
	  for (var j=0; j<5; j++){
	    var referencia = "$" + j;
	    var sustituto = " eval(document.getElementById('textboxApunte' +" + j + ").value) ";
	    formula = formula.replace(referencia, sustituto);
	  }
	  formula = formula + document.getElementById(idTextboxApunte).getAttribute("onblur"); //Al menos, est la comprobacin
	  document.getElementById(idTextboxApunte).setAttribute("onblur", formula);
	}
      }
}/*}}}*/

function limpiarBuscador(){/*{{{*/
//Borra los campos del buscador
  document.getElementById("labelCuentaBuscador").value = "Arrastra Cuenta";
  document.getElementById("labelCuentaBuscador").cuenta= null;
  document.getElementById("checkboxAsientos").removeAttribute("checked");
  document.getElementById("checkboxPrevisiones").removeAttribute("checked");
  document.getElementById("menulistBuscarTipo").selectedIndex = -1;
  document.getElementById("textboxFechaDesde").value = "";
  document.getElementById("textboxFechaHasta").value = "";
}/*}}}*/

function ordenarAsientos(asiento1, asiento2){/*{{{*/
//Una sencilla funcin para ordenar los asientos de una bsqueda por su fecha
  if (asiento1.fecha >= asiento2.fecha) return 1;
  else return -1;
}/*}}}*/
