var contabilidad = opener.contabilidad;
var mesDesde = 0;
var mesHasta = 0;

function iniciar(){/*{{{*/
  //Preparamos los parmetros del Balance
  var parametro = new Object();
  parametro.cuentaBase = contabilidad.verCuentaPorId(opener.document.getElementById("labelCuentaBase").idCuenta);
  if (!parametro.cuentaBase) parametro.cuentaBase = contabilidad;
  var datosFechaDesde = opener.document.getElementById("textboxFechaDesde").value.split("/");
  var datosFechaHasta = opener.document.getElementById("textboxFechaHasta").value.split("/");
  var ahora = new Date();
  if (datosFechaDesde.length == 3)
    parametro.fechaDesde = new Date(datosFechaDesde[2],(datosFechaDesde[1] - 1),datosFechaDesde[0]);
  else
    parametro.fechaDesde = new Date(ahora.getYear() + 1900, 0, 1);
  if (datosFechaHasta.length == 3)
    parametro.fechaHasta = new Date(datosFechaHasta[2],(datosFechaHasta[1] - 1),datosFechaHasta[0]);
  else
    parametro.fechaHasta = new Date(ahora.getYear() + 1900, 11, 31);
  if (opener.document.getElementById("checkboxPorMeses").checked){
    parametro.porMeses = true;
    //Fijamos las variables globales de mesDesde y mesHasta
    mesDesde = parametro.fechaDesde.getYear()*12 + parametro.fechaDesde.getMonth();
    mesHasta = parametro.fechaHasta.getYear()*12 + parametro.fechaHasta.getMonth();
  }
  else parametro.porMeses = false;
  if (opener.document.getElementById("checkboxSumasYSaldos").checked) parametro.sumasYSaldos = true;
  else parametro.sumasYSaldos = false;
  if (opener.document.getElementById("checkboxConPrevisiones").checked) parametro.conPrevisiones = true;
  else parametro.conPrevisiones = false;
  
  var balance = new Balance(contabilidad, parametro);
  balance.preparar();
  balance.calcular();
  document.getElementById("boxBalance").appendChild(balance.ver());
  
  //Algunos detalles del Informe
  var fechaEdicion = new Date();
  document.getElementById("labelFechaEdicion").value = fechaEdicion.getDate() + "/" + (fechaEdicion.getMonth() + 1) + "/" + fechaEdicion.getFullYear();
  var comentario = "";
  if (parametro.cuentaBase == contabilidad)
    comentario += "De todas las cuentas";
  else
    comentario += "De la cuenta " + parametro.cuentaBase.nombre;
  if (parametro.fechaDesde)
    comentario += ", desde " + datosFechaDesde;
  if (parametro.fechaHasta)
    comentario += " hasta " + datosFechaHasta;
  if (parametro.conPrevisiones)
    comentario += ", incluyendo previsiones";
  comentario += ".";
  document.getElementById("labelComentario").value = comentario;
  
}/*}}}*/

//INFORME DE TIPO BALANCE {{{

// La Clase Balance/*{{{*/

function Balance(contabilidad, parametro){ //{{{ 
  this.contabilidad = contabilidad;
  this.parametro = parametro;
  
  this.preparar = prepararBalance;
  this.prepararCuenta = prepararCuentaBalance;
  this.calcular = calcularBalance;
  this.ver = verBalance;

  return this;
} //}}}

function prepararBalance(){/*{{{*/
//Prepara el objeto contabilidad para que podamos preparar balances
  prepararCuentaBalance(this.contabilidad, this.parametro);
}/*}}}*/

function calcularBalance(){/*{{{*/
//Repartimos los apuntes en cada mes de cada cuenta
  for (var i=0; i<this.contabilidad.asiento.length; i++){
    //Si hay definido un periodo de fechas, solo procesamos asientos en ese periodo
    var procesar = true;
    if (this.parametro.fechaHasta != null)
      if (this.contabilidad.asiento[i].fecha > this.parametro.fechaHasta) procesar = false;
    if (!this.parametro.conPrevisiones && this.contabilidad.asiento[i].prevision) procesar = false;
    if (procesar) //Si hay que procesar el asiento...
      for (var j=0; j < this.contabilidad.asiento[i].apunte.length; j++){
	var mes = 0;
	if (this.parametro.porMeses){ 
	  mes = this.contabilidad.asiento[i].fecha.getYear() * 12 + this.contabilidad.asiento[i].fecha.getMonth();
	  if (this.parametro.fechaDesde != null)
	    if (this.contabilidad.asiento[i].fecha < this.parametro.fechaDesde) mes = mesDesde; //Todos los asientos anteriores al periodo se acumulan en el primer mes
	}
	if (this.contabilidad.asiento[i].apunte[j].importe < 0) 
	  this.contabilidad.verCuentaPorId(this.contabilidad.asiento[i].apunte[j].idCuenta).mes[mes].decremento += eval(this.contabilidad.asiento[i].apunte[j].importe);
	else 
	  this.contabilidad.verCuentaPorId(this.contabilidad.asiento[i].apunte[j].idCuenta).mes[mes].incremento += eval(this.contabilidad.asiento[i].apunte[j].importe);
      }
  }
  // Y saldamos todas las cuentas
  for (var i=0; i<this.contabilidad.cuenta.length; i++)
    this.contabilidad.cuenta[i].saldar(this.parametro);
}/*}}}*/

function verBalance (){	//{{{
  //Creamos la estructura del rbol
  var arbol = document.createElement("tree");
  arbol.setAttribute("style","overflow: auto;");
  arbol.setAttribute("flex","1");
  arbol.setAttribute("id", "treeInforme");
  arbolCols = document.createElement("treecols");
  var arbolColCuenta = document.createElement("treecol");
    arbolColCuenta.setAttribute("id","colCuenta");
    arbolColCuenta.setAttribute("primary","true");
    arbolColCuenta.setAttribute("label","Cuenta");
    arbolColCuenta.setAttribute("flex","1");
  arbolCols.appendChild(arbolColCuenta);
  arbol.appendChild(arbolCols);
 
  for (var i=mesDesde; i<=mesHasta; i++){
    //Creamos las columnas para todo el ao
    var mes = new Array("Ene","Feb","Mar","Abr","May","Jun","Jul","Ago","Sep","Oct","Nov","Dic");
    if (this.parametro.sumasYSaldos){
	//Columna de Incremento
	var arbolSplitter = document.createElement("splitter");
	arbolSplitter.setAttribute("class","tree-splitter");
	arbolCols.appendChild(arbolSplitter);
	arbolCol = document.createElement("treecol");
	var idCol = "colIncremento" + i;
	arbolCol.setAttribute("id",idCol);
	arbolCol.setAttribute("label","Inc");
	arbolCol.setAttribute("style","text-align: right;");
	arbolCols.appendChild(arbolCol);
	//Columna de Decremento
	arbolSplitter = document.createElement("splitter");
	arbolSplitter.setAttribute("class","tree-splitter");
	arbolCols.appendChild(arbolSplitter);
	arbolCol = document.createElement("treecol");
	var idCol = "colDecremento" + i;
	arbolCol.setAttribute("id",idCol);
	arbolCol.setAttribute("label","Dec");
	arbolCol.setAttribute("style","text-align: right;");
	arbolCols.appendChild(arbolCol);
      }
      //Columna de Saldo
      arbolSplitter = document.createElement("splitter");
      arbolSplitter.setAttribute("class","tree-splitter");
      arbolCols.appendChild(arbolSplitter);
      arbolCol = document.createElement("treecol");
      var idCol = "colSaldo" + i;
      arbolCol.setAttribute("id",idCol);
      if (this.parametro.porMeses)
	arbolCol.setAttribute("label",mes[i%12]);
      else arbolCol.setAttribute("label","Saldo");
      arbolCol.setAttribute("style","text-align: right;");
      arbolCols.appendChild(arbolCol);
    }
  //Creamos el treechildren
  var arbolTreechildren = document.createElement("treechildren");
  //for (var i=0;i<this.parametro.cuentaBase.cuenta.length;i++)
    //if (this.parametro.cuentaBase.cuenta[i]) 
      //arbolTreechildren.appendChild(this.parametro.cuentaBase.cuenta[i].verTreeitemBalance(this.parametro));
  arbolTreechildren.appendChild(this.parametro.cuentaBase.verTreeitemBalance(this.parametro));
  
  arbol.appendChild(arbolTreechildren);
  return arbol;
} //}}}

//Mtodos que cascamos a pelote en la clase Cuenta //{{{

function prepararCuentaBalance(cuenta, parametro){/*{{{*/
//Prepara la cuenta para el balance
  cuenta.mes = new Array();
  
  for (var j=mesDesde; j<=mesHasta; j++){
    cuenta.mes[j] = new Object();
    cuenta.mes[j].incremento = 0;
    cuenta.mes[j].decremento = 0;
    cuenta.mes[j].saldo = 0;
  }
  //Le aadimos a algunos mtodos a la cuenta
  cuenta.verTreeitemBalance = verTreeitemCuentaBalance;
  cuenta.saldar = saldarCuentaBalance;
  //Y ahora, preparamos sus subcuenta
  for (var i=0; i<cuenta.cuenta.length; i++)
    prepararCuentaBalance(cuenta.cuenta[i], parametro);
}/*}}}*/

function saldarCuentaBalance(parametro){/*{{{*/
//Salda la Cuenta
  for (var i= 0; i< this.cuenta.length; i++)
    this.cuenta[i].saldar(parametro);  //Primero saldamos las subcuentas, si las tiene
  
  for (var j=0; j<this.cuenta.length; j++){
    //La acumulacin de las subcuentas depende del tipo. Bsicamente, las subcuentas del mismo tipo que la cuenta
    //en que se acumula, lo hacen en positivo, y las contrarias, en negativo.
    //Para la comparacin, Activo y Gastos son iguales, como tambin lo son Pasivo e Ingresos
    var signo = -1;
    if ((((this.tipo == "Activo") || (this.tipo == "Gastos")) && ((this.cuenta[j].tipo == "Activo") || (this.cuenta[j].tipo == "Gastos"))) || (((this.tipo == "Pasivo") || (this.tipo == "Ingresos")) && ((this.cuenta[j].tipo == "Pasivo") || (this.cuenta[j].tipo == "Ingresos"))))
      signo = 1;
    for (var k=mesDesde; k<=mesHasta; k++){
      this.mes[k].incremento += signo * this.cuenta[j].mes[k].incremento;
      this.mes[k].decremento += signo * this.cuenta[j].mes[k].decremento;
    }
  }
  //Ahora las cuentas tiene repartidos sus apuntes en incrementos y decrementos
  //Y las saldamos

  for (var l=mesDesde; l<=mesHasta; l++){
    var saldoAnterior = 0;
    if (this.mes[l-1])  //Por si no hay saldo anterior
      saldoAnterior = this.mes[l-1].saldo;
    this.mes[l].saldo = saldoAnterior + this.mes[l].incremento + this.mes[l].decremento;
  }
}/*}}}*/

function verTreeitemCuentaBalance(parametro){/*{{{*/
//Crea el treeitem correspondiente a la cuenta
//El parmetro es igual al del balance.
  var cuentaTreeitem = document.createElement("treeitem");
  var cuentaTreerow = document.createElement("treerow");
  cuentaTreerow.setAttribute("style", "color:red"); //Esto no funciona
  //La celda con el nombre de la cuenta
  var cuentaTreecell = document.createElement("treecell");
  cuentaTreecell.setAttribute("label", this.nombre);
  cuentaTreerow.appendChild(cuentaTreecell);
  
  //Las celdas con los datos de la propia cuenta, para todos los meses del periodo
  for (var j=mesDesde; j<=mesHasta; j++){
    if (parametro.sumasYSaldos){
      //La celda de Incremento
      var cuentaTreecell = document.createElement("treecell");
      var incremento = darFormato(Math.round(this.mes[j].incremento * 100)/100);
      cuentaTreecell.setAttribute("label", incremento);
      cuentaTreecell.setAttribute("style", "text-align: right;");
      cuentaTreerow.appendChild(cuentaTreecell);
      //La celda de Decremento
      var cuentaTreecell = document.createElement("treecell");
      var decremento = darFormato(Math.round(this.mes[j].decremento * 100)/100);
      cuentaTreecell.setAttribute("label", decremento);
      cuentaTreecell.setAttribute("style", "text-align: right;");
      cuentaTreerow.appendChild(cuentaTreecell);
    }
    //La celda de saldo
    var cuentaTreecell = document.createElement("treecell");
    var saldo = darFormato(Math.round(this.mes[j].saldo * 100)/100);
    cuentaTreecell.setAttribute("label", saldo);
    cuentaTreecell.setAttribute("style", "color:red;");	//Esto no funciona
    cuentaTreerow.appendChild(cuentaTreecell);
	
    cuentaTreeitem.appendChild(cuentaTreerow);
  }
  
  //Si hay subcuentas, aadimos un treechildren
  if (this.cuenta.length > 0){
    cuentaTreeitem.setAttribute("container",true);
    cuentaTreeitem.setAttribute("open",true);
    var cuentaTreechildren = document.createElement("treechildren");
    for (var k=0; k<this.cuenta.length; k++)
      if(this.cuenta[k]) cuentaTreechildren.appendChild(this.cuenta[k].verTreeitemBalance(parametro));
	cuentaTreeitem.appendChild(cuentaTreechildren);
  }
    
  return cuentaTreeitem;
}/*}}}*/

//Mtodos de cascamos a pelote en la clase Contabilidad
//function verTreeitemContabilidadBalanace(parametro){
//}

function saldarContabilidadBalance(parametro){/*{{{*/
//Salda la Contabilidad. Es decir, la cuenta raz.
  for (var i= 0; i< this.cuenta.length; i++)
    this.cuenta[i].saldar(parametro);  //Primero saldamos las subcuentas, si las tiene
  
  for (var j=0; j<this.cuenta.length; j++){
    //La acumulacin de las subcuentas depende del tipo. Bsicamente, las subcuentas del mismo tipo que la cuenta
    //en que se acumula, lo hacen en positivo, y las contrarias, en negativo.
    //Para la comparacin, Activo y Gastos son iguales, como tambin lo son Pasivo e Ingresos
    var signo = -1;
    if ((((this.tipo == "Activo") || (this.tipo == "Gastos")) && ((this.cuenta[j].tipo == "Activo") || (this.cuenta[j].tipo == "Gastos"))) || (((this.tipo == "Pasivo") || (this.tipo == "Ingresos")) && ((this.cuenta[j].tipo == "Pasivo") || (this.cuenta[j].tipo == "Ingresos"))))
      signo = 1;
    for (var k=mesDesde; k<=mesHasta; k++){
      this.mes[k].incremento += signo * this.cuenta[j].mes[k].incremento;
      this.mes[k].decremento += signo * this.cuenta[j].mes[k].decremento;
    }
  }
  //Ahora las cuentas tiene repartidos sus apuntes en incrementos y decrementos
  //Y las saldamos

  for (var l=mesDesde; l<=mesHasta; l++){
    var saldoAnterior = 0;
    if (this.mes[l-1])  //Por si no hay saldo anterior
      saldoAnterior = this.mes[l-1].saldo;
    this.mes[l].saldo = saldoAnterior + this.mes[l].incremento + this.mes[l].decremento;
  }
}/*}}}*/

//}}}
//}}}

function darFormato(importe){/*{{{*/
//Devuelve un nmero con dos decimales y el smbolo del euro
  modificador = 0;
  if (importe < 0) modificador = 1;

  importe = "" + importe; //Para que lo trate como una cadena de texto
  
  //Reemplazamos el punto decimal por una coma
  importe = importe.replace(".",",");
  
  //Le ponemos los decimales, si no los tiene
  var temporal = importe.split(",");
  if (temporal.length == 1) importe += ",00";
  else
    if (temporal[1].length == 1) importe += "0";
    
  //Le ponemos los separados de miles
  //var max = (Math.round(importe.length/4) - 1);
  var max = (importe.length-(6+modificador))/3;
  for (var i=0; i<max; i++)
    importe = importe.substr(0,importe.length - (6+4*i)) + "." + importe.substr(importe.length - (6+4*i), importe.length);
  
  //Le aadimos el smbolo del euro
  importe += contabilidad.moneda;
  
  return importe;
}/*}}}*/

