// Variables Globales/*{{{*/
var contabilidad = parent.parent.contabilidad;
var cuentaTrabajo;
var idCuentaTrabajo;
var editando = false;
var creandoSubcuenta = false;

var observerCuenta = {
  getSupportedFlavours : function () {
    var flavours = new FlavourSet();
    flavours.appendFlavour("cuenta");
    return flavours;
  },
  onDrop: function (evt,dropdata,session){
    //Tenemos que estar editando o creando una subcuenta
    if ((editando) || (creandoSubcuenta)){
      var cuentaSeleccionada = contabilidad.verCuentaPorId(dropdata.data);
      if (!cuentaSeleccionada.fin){  //Solo No aceptamos cuentas finales
	evt.target.setAttribute("value", cuentaSeleccionada.nombre);
	evt.target.setAttribute("tooltiptext", cuentaSeleccionada.nombre);
	evt.target.idCuenta = dropdata.data;
      }
    }
  },
  onDragOver: function (evt, flav, dragSession){
    //Esta funcin hace falta aunque no haga nada.
  }
};  //Ojo a las , y al ;
/*}}}*/

function crearSubcuenta(){  //{{{
//Crea una nueva Subcuenta en la cuenta seleccionada
  creandoSubcuenta = true;  
  
  //Borramos el formulario
  document.getElementById("nombre").value = "";
  document.getElementById("tipo").selectedIndex = 0;
  document.getElementById("pgc").value = "";
  document.getElementById("fin").setAttribute("checked","false");

  //Activamos los campos
  document.getElementById("nombre").removeAttribute("disabled");
  document.getElementById("tipo").removeAttribute("disabled");
  document.getElementById("pgc").removeAttribute("disabled");
  document.getElementById("fin").removeAttribute("disabled");

  //Ponemos como padre a la cuenta seleccionada
  document.getElementById("labelCuentaPadre").idCuenta = parent.cuentaSeleccionada.id;
  document.getElementById("labelCuentaPadre").value = parent.cuentaSeleccionada.nombre;
  document.getElementById("labelCuentaPadre").tooltext = parent.cuentaSeleccionada.nombre;

  //Activamos los botones
  document.getElementById("botonEditar").setAttribute("disabled","true");
  document.getElementById("botonNueva").setAttribute("disabled","true");
  document.getElementById("botonBorrar").setAttribute("disabled","true");
  document.getElementById("botonAceptar").removeAttribute("disabled");
  document.getElementById("botonCancelar").removeAttribute("disabled");
  
  document.getElementById("nombre").focus();

}  //}}}

function editar(){ //{{{
//Edita los datos de una cuenta
  editando = true;
  
  //Activa el formulario para Edicin
  document.getElementById("nombre").removeAttribute("disabled");
  document.getElementById("pgc").removeAttribute("disabled");
  if (!cuentaTrabajo.fin){	// A las cuentas finales no se les puede cambiar el tipo
    document.getElementById("tipo").removeAttribute("disabled");
  if (cuentaTrabajo.cuenta.length == 0)  // Una cuenta con subcuentas no puede cambiarse a final
      document.getElementById("fin").removeAttribute("disabled");
  }
  
  //Activamos los botones
  document.getElementById("botonEditar").setAttribute("disabled","true");
  document.getElementById("botonNueva").setAttribute("disabled","true");
  document.getElementById("botonBorrar").setAttribute("disabled","true");
  document.getElementById("botonAceptar").removeAttribute("disabled");
  document.getElementById("botonCancelar").removeAttribute("disabled");
  
  document.getElementById("nombre").focus();
} //}}}

function borrar(){  //{{{
//Borra la cuenta seleccionada, tras la confirmacin
  //Las cuentas con subcuentas o finales con asientos no se pueden borrar
  var cuentaTrabajo = parent.cuentaSeleccionada;
  if (cuentaTrabajo.fin){
    if (contabilidad.tieneAsientos(cuentaTrabajo.id)){
      alert("No se puede borrar una cuenta final con asientos");
      return;
    }
  }
  else
    if (cuentaTrabajo.cuenta.length > 0){
      alert("No se puede borrar una cuenta con subcuentas.");
      return;
    }
    
  if(confirm("Estas segura/o de que quieres BORRAR la cuenta " + cuentaTrabajo.nombre + "?")){
    contabilidad.borrarCuenta(cuentaTrabajo.id);
    contabilidad.modificada = true;
    parent.verCuentas();
  }
  cancelar();
}  //}}}

function aceptar(){  //{{{
  //Actualizamos la informacin de la cuenta con los datos del formulario

  //Primero comprobamos algunas cosas
  if (creandoSubcuenta){
    //Comprobamos que no hay una cuenta con el mismo PGC y distinto nombre
    var nombre = contabilidad.existeCuenta(document.getElementById("nombre").value,document.getElementById("pgc").value);
    if(nombre){
      if (!confirm("Vaya, vaya!\nLa cuenta \""+nombre+"\" tiene el mismo PGC.\nSeguro que quieres crear una cuenta con el mismo PGC?"))
	return;
    } 
  }
  if (editando){
    contabilidad.cambiarPadreCuenta(cuentaTrabajo, contabilidad.verCuentaPorId(document.getElementById("labelCuentaPadre").idCuenta));
  }
  else{
    //Estamos creando una subcuenta
    alert(document.getElementById("labelCuentaPadre").idCuenta);
    cuentaTrabajo = contabilidad.nuevaCuenta(document.getElementById("labelCuentaPadre").idCuenta);
  }

  //Sentencias comunes a editar e insertar
  contabilidad.verCuentaPorId(document.getElementById("labelCuentaPadre").idCuenta).abierta = "nueva subcuenta";
  cuentaTrabajo.nombre = document.getElementById("nombre").value;
  cuentaTrabajo.tipo = document.getElementById("tipo").selectedItem.getAttribute("label");
  cuentaTrabajo.pgc = document.getElementById("pgc").value;
  if (document.getElementById("fin").checked) cuentaTrabajo.fin = true;
  else cuentaTrabajo.fin = false;
  
  contabilidad.modificada = true;

  //Refrescamos el rbol de cuentas
  parent.verCuentas();
  
  cancelar();
} //}}}

function cancelar(){  //{{{
//Devuelve el formulario a modo consulta (inactivo)
  document.getElementById("nombre").setAttribute("disabled","true");
  document.getElementById("tipo").setAttribute("disabled","true");
  document.getElementById("pgc").setAttribute("disabled","true");
  document.getElementById("fin").setAttribute("disabled","true");
  
  document.getElementById("botonEditar").setAttribute("disabled","true");
  document.getElementById("botonAceptar").setAttribute("disabled","true");
  document.getElementById("botonCancelar").setAttribute("disabled","true");

  //Permitimos de nuevo la navegacin
  editando = false; 
  creandoSubcuenta = false;
  parent.procesando = false; 
  
} //}}}

function iniciar(){/*{{{*/
}/*}}}*/

function mostrar(){  //{{{
  //Solo mostramos si no estamos editando, ni creando una subcuenta o una cuenta y si no est refrescandose el rbol
  if (!editando && !creandoSubcuenta && (parent.treeCuentas.currentIndex != -1)){
    cuentaTrabajo = parent.cuentaSeleccionada;	//La guardo por si navegan (por ejemplo, para cambiar el padre)
    idCuentaTrabajo = cuentaTrabajo.id;
    //Muestra la informacin de la cuenta indicada
    if (cuentaTrabajo.padre){
      document.getElementById("labelCuentaPadre").value = cuentaTrabajo.padre.nombre;
      document.getElementById("labelCuentaPadre").idCuenta = cuentaTrabajo.padre.id;
    }
    document.getElementById("nombre").value = cuentaTrabajo.nombre;
    listaTipo = document.getElementById("tipo");
    listaTipo.selectedItem = listaTipo.getElementsByAttribute("label", cuentaTrabajo.tipo)[0];
    document.getElementById("pgc").value = cuentaTrabajo.pgc;
    if (cuentaTrabajo.fin) document.getElementById("fin").setAttribute("checked","true");
    else document.getElementById("fin").setAttribute("checked","false");

    //Activacin de botones
    document.getElementById("botonNueva").removeAttribute("disabled");
    document.getElementById("botonEditar").removeAttribute("disabled");
    document.getElementById("botonBorrar").removeAttribute("disabled");
    
    //Las cuentas finales NO pueden tener subcuentas
    if (cuentaTrabajo.fin) document.getElementById("botonNueva").setAttribute("disabled","true");
  }
}  //}}}
