var contabilidad = opener.contabilidad;

function iniciar(){/*{{{*/
  //Preparamos los parmetros del Balance
  var parametro = new Object();
  parametro.idCuentaBase = opener.document.getElementById("labelCuentaBaseDiario").idCuenta;
  var datosFechaDesde = opener.document.getElementById("textboxFechaDesdeDiario").value.split("/");
  if (datosFechaDesde.length == 3)
    parametro.fechaDesde = new Date(datosFechaDesde[2],(datosFechaDesde[1] - 1),datosFechaDesde[0]);
  else
    parametro.fechaDesde = null;
  var datosFechaHasta = opener.document.getElementById("textboxFechaHastaDiario").value.split("/");
  if (datosFechaHasta.length == 3)
    parametro.fechaHasta = new Date(datosFechaHasta[2],(datosFechaHasta[1] - 1),datosFechaHasta[0]);
  else
    parametro.fechaHasta = null;
  parametro.tipo = opener.document.getElementById("menulistTipoDiario").selectedItem.tipo;
  if (opener.document.getElementById("checkboxConPrevisionesDiario").checked) parametro.conPrevisiones = true;
  else parametro.conPrevisiones = false;
  
  var diario = new Diario(contabilidad, parametro);
  diario.preparar();
  document.getElementById("boxInforme").appendChild(diario.ver());
  
  //Algunos detalles del Informe
  var fechaEdicion = new Date();
  document.getElementById("labelFechaEdicion").value = fechaEdicion.getDate() + "/" + (fechaEdicion.getMonth() + 1) + "/" + fechaEdicion.getFullYear();
  var comentario = "";
  if (parametro.idCuentaBase == null)
    comentario += "De todas las cuentas";
  else
    comentario += "De la cuenta " + this.contabilidad.verCuentaPorId(parametro.idCuentaBase).nombre;
  if (parametro.fechaDesde)
    comentario += ", desde " + datosFechaDesde;
  if (parametro.fechaHasta)
    comentario += " hasta " + datosFechaHasta;
  if (parametro.conPrevisiones)
    comentario += ", incluyendo previsiones";
  comentario += ".";
  document.getElementById("labelComentario").value = comentario;
  
}/*}}}*/

//INFORME DE TIPO LIBRO DIARIO {{{ 

// La Clase Diario/*{{{*/

function Diario(contabilidad, parametro){ //{{{ 
  this.contabilidad = contabilidad;
  this.parametro = parametro;
  
  this.preparar = prepararDiario;
  this.ver = verDiario;

  return this;
} //}}}

function prepararDiario(){
//Prepara la elaboracin del Diario. Es decir, que ordena los asientos por fecha
  this.contabilidad.asiento.sort(ordenarAsientos);
}

function verDiario (){	//{{{
//Devuelve el rbol del Libro Diario
  //Creamos la estructura del rbol
  var arbol = document.createElement("tree");
  arbol.setAttribute("id", "treeInforme");
  arbol.setAttribute("style","overflow: auto;");
  arbol.setAttribute("flex","1");
  arbolCols = document.createElement("treecols");

  //Columna de Fecha
  var arbolColFecha = document.createElement("treecol");
  arbolColFecha.setAttribute("id","colFecha");
  arbolColFecha.setAttribute("primary","true");
  arbolColFecha.setAttribute("label","Fecha");
  arbolColFecha.setAttribute("flex","1");
  arbolCols.appendChild(arbolColFecha);
  
  arbolSplitter = document.createElement("splitter");
  arbolSplitter.setAttribute("class","tree-splitter");
  arbolCols.appendChild(arbolSplitter);
  
  //Columna de Cuenta/Nombre
  var arbolColCuenta = document.createElement("treecol");
  arbolColCuenta.setAttribute("id","colCuenta");
  arbolColCuenta.setAttribute("label","Cuenta");
  arbolColCuenta.setAttribute("flex","1");
  arbolCols.appendChild(arbolColCuenta);
  
  arbolSplitter = document.createElement("splitter");
  arbolSplitter.setAttribute("class","tree-splitter");
  arbolCols.appendChild(arbolSplitter);
  
  //Columna de Importe
  var arbolColImporte = document.createElement("treecol");
  arbolColImporte.setAttribute("id","colImporte");
  arbolColImporte.setAttribute("label","Importe");
  arbolColImporte.setAttribute("style", "text-align: right;");
  arbolColImporte.setAttribute("flex","1");
  arbolCols.appendChild(arbolColImporte);
  
  arbol.appendChild(arbolCols);
  
  //Creamos el treechildren
  var arbolTreechildren = document.createElement("treechildren");

  //Y ahora, aadimos un treeitem por cada asiento
  for (var i=0; i<this.contabilidad.asiento.length; i++){
    //Vemos si el asiento debe ir en el informe
    if (this.parametro.fechaDesde != null)
      if (this.contabilidad.asiento[i].fecha < this.parametro.fechaDesde) continue;
    if (this.parametro.fechaHasta != null)
      if (this.contabilidad.asiento[i].fecha > this.parametro.fechaHasta) continue;
    if (!this.parametro.conPrevisiones && this.contabilidad.asiento[i].prevision) continue;
    if ((this.parametro.tipo != null) && (this.contabilidad.asiento[i].tipo.id != this.parametro.tipo.id)) continue;
    if (this.parametro.idCuentaBase != null){
      var procesar = false;
      for (var j=0; j<this.contabilidad.asiento[i].apunte.length; j++)
	if (this.contabilidad.asiento[i].apunte[j].idCuenta == this.parametro.idCuentaBase){
	  procesar = true;
	  break;
	}
      if (!procesar) continue;
    }
    
    //Creamos el treeitem del asiento
    var treeitemAsiento = document.createElement("treeitem");
    treeitemAsiento.setAttribute("style", "color:blue;");
    
    //La primera fila es la cabecera
    var treerowAsiento = document.createElement("treerow");
    treerowAsiento.setAttribute("style","font-weigth: bold;");
    
    var treecellFecha = document.createElement("treecell");
    var fecha = this.contabilidad.asiento[i].fecha;
    treecellFecha.setAttribute("label",fecha.getDate() + "/" + (fecha.getMonth() + 1) + "/" + fecha.getFullYear()); 
    treerowAsiento.appendChild(treecellFecha);
    
    var treecellNombre = document.createElement("treecell");
    treecellNombre.setAttribute("label",i + " - " + this.contabilidad.asiento[i].nombre); 
    treecellNombre.setAttribute("style", "font-weight:bold;");
    treerowAsiento.appendChild(treecellNombre);
    
    var treecellVacia = document.createElement("treecell");
    treecellVacia.setAttribute("label",""); 
    treerowAsiento.appendChild(treecellVacia);

    //Aadimos la fila del Asiento al treeitem del rbol, y hacemos que se pueda desplegar
    treeitemAsiento.appendChild(treerowAsiento);
    treeitemAsiento.setAttribute("container", true);
    treeitemAsiento.setAttribute("open", true);

    //Aadimos el item del Asiento al children general
    arbolTreechildren.appendChild(treeitemAsiento);

    //El segundo nivel (treechildren) son los apuntes del asiento
    var treechildrenApuntes = document.createElement("treechildren");

    //Y tiene un treeitem (con una fila y sus celdas) por cada apunte
    for (var j=0; j<this.contabilidad.asiento[i].apunte.length; j++){
      var treeitemApunte = document.createElement("treeitem");
      var treerowApunte = document.createElement("treerow");
      //La celda de la fecha
      var treecellFecha = document.createElement("treecell");
      treecellFecha.setAttribute("label", "");
      treerowApunte.appendChild(treecellFecha);
      //La celda de la cuenta
      var treecellCuenta = document.createElement("treecell");
      var cuentaApunte = this.contabilidad.verCuentaPorId(this.contabilidad.asiento[i].apunte[j].idCuenta);
      treecellCuenta.setAttribute("label", "(" + cuentaApunte.pgc + ") " + cuentaApunte.nombre);
      treerowApunte.appendChild(treecellCuenta);
      //La celda del importe
      var treecellImporte = document.createElement("treecell");
      treecellImporte.setAttribute("label", darFormato(this.contabilidad.asiento[i].apunte[j].importe));
      treerowApunte.appendChild(treecellImporte);

      //Aadimos la fila al item
      treeitemApunte.appendChild(treerowApunte);
      //Y el item al treechildren
      treechildrenApuntes.appendChild(treeitemApunte);
    }
    //Hemos terminado con los apuntes
    //Aadimos el treechildren de apuntes al treeitem del asiento
    treeitemAsiento.appendChild(treechildrenApuntes);

    //Y el item de asiento lo aadimos al treechildren general
    arbolTreechildren.appendChild(treeitemAsiento);
  }
  //Finalmente, aadimos el treechildren (de asientos) al arbolTreeChildren
  arbol.appendChild(arbolTreechildren);

  return arbol;
} //}}}

function darFormato(importe){/*{{{*/
//Devuelve un nmero con dos decimales y el smbolo del euro
  modificador = 0;
  if (importe < 0) modificador = 1;

  importe = "" + importe; //Para que lo trate como una cadena de texto
  
  //Reemplazamos el punto decimal por una coma
  importe = importe.replace(".",",");
  
  //Le ponemos los decimales, si no los tiene
  var temporal = importe.split(",");
  if (temporal.length == 1) importe += ",00";
  else
    if (temporal[1].length == 1) importe += "0";
    
  //Le ponemos los separados de miles
  //var max = (Math.round(importe.length/4) - 1);
  var max = (importe.length-(6+modificador))/3;
  for (var i=0; i<max; i++)
    importe = importe.substr(0,importe.length - (6+4*i)) + "." + importe.substr(importe.length - (6+4*i), importe.length);
  
  //Le aadimos el smbolo del euro
  importe += contabilidad.moneda;
  
  return importe;
}/*}}}*/

function ordenarAsientos(asiento1, asiento2){
//Ordena los asientos por fecha
  if (asiento1.fecha >= asiento2.fecha) return 1;
  else return -1;
}

//Funciones del Men de Balance

function menuitemImprimir(){
//Imprime el Informe de Balance
  window.print();
}

function menuitemCSV(){
//Guarda el informe en formato CSV (Comma Separated Value)
}

function menuitemHTML(){
//Guarda el informe en formato HTML
}

