var contabilidad = parent.parent.contabilidad;/*{{{*/

var observerCuenta = {
  getSupportedFlavours : function () {
    var flavours = new FlavourSet();
    flavours.appendFlavour("cuenta");
    return flavours;
  },
  onDragStart: function (evt, transferData, action){
    //Borramos la cuenta
    evt.target.setAttribute("value", "Arrastra Cuenta");
    evt.target.cuenta = null;

  },
  onDrop: function (evt,dropdata,session){
    //Solo el Balance acepta cuentas no finales
    var cuentaSeleccionada = contabilidad.verCuentaPorId(dropdata.data);
    if (!(cuentaSeleccionada.fin) && !(document.getElementById('deckInformes').selectedIndex == 0)) return;
    evt.target.setAttribute("value", cuentaSeleccionada.nombre);
    evt.target.setAttribute("tooltiptext", cuentaSeleccionada.verNombreCompleto());
    evt.target.idCuenta = dropdata.data;
  },
  onDragOver: function (evt, flav, dragSession){
    //Esta funcin hace falta aunque no haga nada.
  }
};  //Ojo a las , y al ;
/*}}}*/

function iniciar(){/*{{{*/
  cargarTiposAsiento(document.getElementById("menulistTipoDiario"));
  cargarTiposAsiento(document.getElementById("menulistTipoMayor"));
 }/*}}}*/

function botonPreparar(){/*{{{*/
//Lanzamos el informe correspondiente
  switch (document.getElementById('menulistTipo').selectedIndex) {
    case 0:
      var informe = "balance";
      break;
    case 1:
      var informe = "balancePGC";
      break;
    case 2:
      var informe = "diario";
      break;
    case 3:
      var informe = "mayor";
      break;
    default:
      alert("Error de programacin. Tipo de Informe desconocido");
      return;
  }
    
    informe = "chrome://econtab/content/" + informe + ".xul";
    //windowInforme = window.open(informe, "windowInforme", "chrome, dependent, centerscreen");
    windowInforme = window.open(informe, "", "chrome,centerscreen,resizable");
}/*}}}*/

function comprobarFecha(campo){ //{{{
//Comprueba que el campo contenga una fecha vlida
  var error = false;
  var fecha = campo.value;
  if (fecha != ""){
    var datosFecha = fecha.split("/");
    if(datosFecha.length != 3) error=true;
    else if(datosFecha[0] > 31) error=true;
      else if(datosFecha[1] > 12) error=true;
	else if(datosFecha[2].length != 4) error=true;
  }
  if(error){
    alert("Oye! Esta fecha no es vlida.\nDebe ser del tipo \"dd/mm/aaaa\".");
    campo.value="";
    return error;
  }
} //}}}

function cargarTiposAsiento(menulist){/*{{{*/
  var menupopup = menulist.firstChild;
  //Borramos la lista
  while (menupopup.hasChildNodes())
    menupopup.removeChild(menupopup.firstChild);
  //Creamos un primer elemento vaco
  var menuitem = document.createElement("menuitem");
  menuitem.setAttribute("label", "-- Todos --");
  menuitem.tipo = null;
  menupopup.appendChild(menuitem);
  for (var i=0; i< contabilidad.tipoAsiento.length; i++){
    var menuitem = document.createElement("menuitem");
    menuitem.setAttribute("label", contabilidad.tipoAsiento[i].nombre);
    menuitem.tipo = contabilidad.tipoAsiento[i];
    menupopup.appendChild(menuitem);
  }
  menulist.selectedIndex = 0;
}/*}}}*/

