var contabilidad = opener.contabilidad;

function iniciar(){/*{{{*/
  //Preparamos los parmetros del Informe
  var parametro = new Object();
  parametro.idCuentaBase = opener.document.getElementById("labelCuentaBaseMayor").idCuenta;
  if (parametro.idCuentaBase == null){
    alert("Es necesario indicar una CUENTA FINAL para preparar el Libro Mayor.");
    window.close();
    return;
  }
  var datosFechaDesde = opener.document.getElementById("textboxFechaDesdeMayor").value.split("/");
  if (datosFechaDesde.length == 3)
    parametro.fechaDesde = new Date(datosFechaDesde[2],(datosFechaDesde[1] - 1),datosFechaDesde[0]);
  else
    parametro.fechaDesde = null;
  var datosFechaHasta = opener.document.getElementById("textboxFechaHastaMayor").value.split("/");
  if (datosFechaHasta.length == 3)
    parametro.fechaHasta = new Date(datosFechaHasta[2],(datosFechaHasta[1] - 1),datosFechaHasta[0]);
  else
    parametro.fechaHasta = null;
  parametro.tipo = opener.document.getElementById("menulistTipoMayor").selectedItem.tipo;
  if (opener.document.getElementById("checkboxConPrevisionesMayor").checked) parametro.conPrevisiones = true;
  else parametro.conPrevisiones = false;
  
  var mayor = new Mayor(contabilidad, parametro);
  mayor.preparar();
  document.getElementById("boxInforme").appendChild(mayor.ver());
  
  //Algunos detalles del Informe
  var fechaEdicion = new Date();
  document.getElementById("labelFechaEdicion").value = fechaEdicion.getDate() + "/" + (fechaEdicion.getMonth() + 1) + "/" + fechaEdicion.getFullYear();
  var comentario = "";
  comentario += "De la cuenta " + parametro.cuentaBase.nombre;
  if (parametro.fechaDesde)
    comentario += ", desde " + datosFechaDesde;
  if (parametro.fechaHasta)
    comentario += " hasta " + datosFechaHasta;
  if (parametro.conPrevisiones)
    comentario += ", incluyendo previsiones";
  comentario += ".";
  document.getElementById("labelComentario").value = comentario;
  
}/*}}}*/

//INFORME DE TIPO LIBRO MAYOR {{{ 

// La Clase Mayor/*{{{*/

function Mayor(contabilidad, parametro){ //{{{ 
  this.contabilidad = contabilidad;
  this.parametro = parametro;
  
  this.preparar = prepararMayor;
  this.ver = verMayor;

  return this;
} //}}}

function prepararMayor(){/*{{{*/
//Prepara la elaboracin del Diario. Es decir, que ordena los asientos por fecha
  this.contabilidad.asiento.sort(ordenarAsientos);
}/*}}}*/

function verMayor(){	//{{{
//Devuelve el rbol del Libro Mayor
  //Creamos la estructura del rbol
  var arbol = document.createElement("tree");
  arbol.setAttribute("id", "treeInforme");
  arbol.setAttribute("style","overflow: auto;");
  arbol.setAttribute("flex","1");
  arbolCols = document.createElement("treecols");

  //Columna de Fecha
  var arbolColFecha = document.createElement("treecol");
  arbolColFecha.setAttribute("id","colFecha");
  arbolColFecha.setAttribute("primary","true");
  arbolColFecha.setAttribute("label","Fecha");
  arbolColFecha.setAttribute("flex","1");
  arbolCols.appendChild(arbolColFecha);
  
  arbolSplitter = document.createElement("splitter");
  arbolSplitter.setAttribute("class","tree-splitter");
  arbolCols.appendChild(arbolSplitter);
  
  //Columna de Tipo de Asiento
  var arbolColTipo = document.createElement("treecol");
  arbolColTipo.setAttribute("id","colTipo");
  arbolColTipo.setAttribute("label","Tipo");
  arbolColTipo.setAttribute("flex","1");
  arbolCols.appendChild(arbolColTipo);
  
  arbolSplitter = document.createElement("splitter");
  arbolSplitter.setAttribute("class","tree-splitter");
  arbolCols.appendChild(arbolSplitter);
  
  //Columna de Cuenta
  var arbolColCuenta = document.createElement("treecol");
  arbolColCuenta.setAttribute("id","colCuenta");
  arbolColCuenta.setAttribute("label","Cuenta");
  arbolColCuenta.setAttribute("flex","1");
  arbolCols.appendChild(arbolColCuenta);
  
  arbolSplitter = document.createElement("splitter");
  arbolSplitter.setAttribute("class","tree-splitter");
  arbolCols.appendChild(arbolSplitter);
  
  //Columna de Importe
  var arbolColImporte = document.createElement("treecol");
  arbolColImporte.setAttribute("id","colImporte");
  arbolColImporte.setAttribute("label","Importe");
  arbolColImporte.setAttribute("style", "text-align: right;");
  arbolColImporte.setAttribute("flex","1");
  arbolCols.appendChild(arbolColImporte);
  
  arbolSplitter = document.createElement("splitter");
  arbolSplitter.setAttribute("class","tree-splitter");
  arbolCols.appendChild(arbolSplitter);
  
  //Columna de Saldo
  var arbolColSaldo = document.createElement("treecol");
  arbolColSaldo.setAttribute("id","colSaldo");
  arbolColSaldo.setAttribute("label","Saldo");
  arbolColSaldo.setAttribute("style", "text-align: right;");
  arbolColSaldo.setAttribute("flex","1");
  arbolCols.appendChild(arbolColSaldo);
  
  arbolSplitter = document.createElement("splitter");
  arbolSplitter.setAttribute("class","tree-splitter");
  arbolCols.appendChild(arbolSplitter);
  
  arbol.appendChild(arbolCols);
  
  //Creamos el treechildren
  var arbolTreechildren = document.createElement("treechildren");

  var saldoAcumulado = 0;
  //Habra que calcular antes el saldo inicial
  //Y ahora, aadimos un treeitem por cada asiento que tenga un apunte de la cuenta seleccionada
  for (var i=0; i<this.contabilidad.asiento.length; i++){
    //Vemos si el asiento debe ir en el informe
    if (this.parametro.fechaHasta != null)
      if (this.contabilidad.asiento[i].fecha > this.parametro.fechaHasta) continue;
    if (!this.parametro.conPrevisiones && this.contabilidad.asiento[i].prevision) continue;
    for (var j=0; j<this.contabilidad.asiento[i].apunte.length; j++)
      if (this.contabilidad.asiento[i].apunte[j].idCuenta == this.parametro.idCuentaBase){
	if ((this.parametro.fechaDesde != null) && (this.contabilidad.asiento[i].fecha < this.parametro.fechaDesde)){
	  saldoAcumulado = eval(saldoAcumulado) + eval(this.contabilidad.asiento[i].apunte[j].importe);
	  continue;
	}
	if ((this.parametro.tipo != null) && (this.contabilidad.asiento[i].tipo.id != this.parametro.tipo.id)) continue;
	
	//Este apunte S va al Libro Mayor
	saldoAcumulado = eval(saldoAcumulado) + eval(this.contabilidad.asiento[i].apunte[j].importe); 
	arbolTreechildren.appendChild(verTreeitem(this.contabilidad.asiento[i].fecha, this.contabilidad.asiento[i].tipo.nombre, this.contabilidad.asiento[i].nombre, this.contabilidad.asiento[i].apunte[j].importe, saldoAcumulado));
      }
  }
  
  //Finalmente, aadimos el treechildren (de apuntes) al arbolTreeChildren
  arbol.appendChild(arbolTreechildren);

  return arbol;
} //}}}

function verTreeitem(fecha, tipo, nombre, importe, saldo){/*{{{*/
//Devuelve un treeitem con los datos indicados
  var treeitemApunte = document.createElement("treeitem");
  var treerowApunte = document.createElement("treerow");
  var treecellFecha = document.createElement("treecell");
  var pfecha = fecha;
  if (fecha != "")
    pfecha = fecha.getDate() + "/" + (fecha.getMonth() + 1) + "/" + fecha.getFullYear();
  treecellFecha.setAttribute("label", pfecha); 
  treerowApunte.appendChild(treecellFecha);
  var treecellTipo = document.createElement("treecell");
  treecellTipo.setAttribute("label", tipo); 
  treerowApunte.appendChild(treecellTipo);
  var treecellNombre = document.createElement("treecell");
  treecellNombre.setAttribute("label", nombre); 
  treerowApunte.appendChild(treecellNombre);
  var treecellImporte = document.createElement("treecell");
  treecellImporte.setAttribute("label", darFormato(importe)); 
  treerowApunte.appendChild(treecellImporte);
  var treecellSaldo = document.createElement("treecell");
  treecellSaldo.setAttribute("label", darFormato(saldo)); 
  treerowApunte.appendChild(treecellSaldo);
  treeitemApunte.appendChild(treerowApunte);
  
  return treeitemApunte;
}/*}}}*/

function darFormato(importe){/*{{{*/
//Devuelve un nmero con dos decimales y el smbolo del euro
  modificador = 0;
  if (importe < 0) modificador = 1;

  importe = "" + importe; //Para que lo trate como una cadena de texto
  
  //Reemplazamos el punto decimal por una coma
  importe = importe.replace(".",",");
  
  //Le ponemos los decimales, si no los tiene
  var temporal = importe.split(",");
  if (temporal.length == 1) importe += ",00";
  else
    if (temporal[1].length == 1) importe += "0";
    
  //Le ponemos los separados de miles
  //var max = (Math.round(importe.length/4) - 1);
  var max = (importe.length-(6+modificador))/3;
  for (var i=0; i<max; i++)
    importe = importe.substr(0,importe.length - (6+4*i)) + "." + importe.substr(importe.length - (6+4*i), importe.length);
  
  //Le aadimos el smbolo del euro
  importe += contabilidad.moneda;
  
  return importe;
}/*}}}*/

function ordenarAsientos(asiento1, asiento2){/*{{{*/
//Ordena los asientos por fecha
  if (asiento1.fecha >= asiento2.fecha) return 1;
  else return -1;
}/*}}}*/

//Funciones del Men de Balance

function menuitemImprimir(){
//Imprime el Informe de Balance
  window.print();
}

function menuitemCSV(){
//Guarda el informe en formato CSV (Comma Separated Value)
}

function menuitemHTML(){
//Guarda el informe en formato HTML
}

