// Variables Globales/*{{{*/
var contabilidad = parent.parent.contabilidad;
var predefinidoSeleccionado;
var maxApunte = 0;
var estadoIU = "Espera";

var observerCuenta = {
  getSupportedFlavours : function () {
    var flavours = new FlavourSet();
    flavours.appendFlavour("cuenta");
    return flavours;
  },
  onDrop: function (evt,dropdata,session){
    //Admitimos tambin cuentas No Finales
    var cuentaSeleccionada = contabilidad.verCuentaPorId(dropdata.data);
    evt.target.setAttribute("value", cuentaSeleccionada.nombre);
    evt.target.setAttribute("tooltiptext", cuentaSeleccionada.nombre);
    evt.target.idCuenta = dropdata.data;
  },
  onDragOver: function (evt, flav, dragSession){
    //Esta funcin hace falta aunque no haga nada.
  }
};  //Ojo a las , y al ;/*}}}*/

function iniciar(){/*{{{*/
  cargarTiposAsiento(document.getElementById("menupopupTipo"));
  verPredefinidos();
 }/*}}}*/

function cargarTiposAsiento(menupopup){/*{{{*/
  //Borramos la lista
  while (menupopup.hasChildNodes())
    menupopup.removeChild(menupopup.firstChild);
  for (var i=0; i< contabilidad.tipoAsiento.length; i++){
    var menuitem = document.createElement("menuitem");
    menuitem.setAttribute("label", contabilidad.tipoAsiento[i].nombre);
    menuitem.tipo = contabilidad.tipoAsiento[i];
    menupopup.appendChild(menuitem);
  }
}/*}}}*/

function botonNuevo(){/*{{{*/
//Respuesta al botn Nuevo
  cambiarEstado("Insercin");
  borrarCampos();
}/*}}}*/

function botonEditar(){/*{{{*/
//Respuesta al botn Editar
  cambiarEstado("Edicin");
}/*}}}*/

function botonBorrar(){/*{{{*/
//Borra el predefinido seleccionado, tras la confirmacin
  //Habra que comprobar que su cuenta est vaca
  if(confirm("Estas segura/o de que quieres BORRAR este predefinido?")){
    contabilidad.borrarPredefinido(predefinidoSeleccionado);
    contabilidad.modificada = false;
    verPredefinidos();
  }
 botonCancelar();
}/*}}}*/

function botonAceptar(){/*{{{*/ 
//Respuesta al botn Aceptar

  if (estadoIU == "Insercin") predefinido = contabilidad.nuevoPredefinido();
  else predefinido = predefinidoSeleccionado;

  predefinido.nombre = document.getElementById("textboxNombre").value;
  predefinido.tipo = document.getElementById("menulistTipo").selectedItem.tipo;
  predefinido.notas = document.getElementById("textboxNotas").value;
  //Borramos todos los apuntes para volver a crearlos
  predefinido.borrarApuntes(); 
  //Aadimos los apuntes
  for (var i=0; i<maxApunte; i++){
    idLabelApunte = "labelApunte" + i;
    idTextboxApunte = "textboxApunte" + i;
    var idCuenta = document.getElementById(idLabelApunte).idCuenta;
    var formula = document.getElementById(idTextboxApunte).value;
    if (idCuenta != null) {
      var apunte = predefinido.nuevoApunte();
      apunte.idCuenta = idCuenta;
      apunte.formula = formula;
    }
  }

  contabilidad.modificada = true;

  //Refrescamos la lista de predefinidos
  verPredefinidos();

  botonCancelar();
}/*}}}*/

function botonCancelar(){/*{{{*/
//Respuesta al botn Cancelar
  cambiarEstado("Espera");
  borrarCampos();
}/*}}}*/

function verPredefinidos(){/*{{{*/
//Carga la lista de predefinidos
  listboxPredefinidos = document.getElementById("listboxPredefinidos");
  while (listboxPredefinidos.removeItemAt(2)); //Borramos la lista
  
  for (var i=0; i<contabilidad.predefinido.length; i++){
    item = document.createElement("listitem");
    itemCellNombre = document.createElement("listcell");
    itemCellNombre.setAttribute("label", contabilidad.predefinido[i].nombre);
    item.appendChild(itemCellNombre);
    //Y le aadimos el puntero al propio predefinido
    item.predefinido = contabilidad.predefinido[i];
    listboxPredefinidos.appendChild(item);
  }
}/*}}}*/

function cambiarEstado(estado){/*{{{*/
//Cambia el estado del Interfaz de Usuario
  estadoIU = estado;
  switch (estado){
    //Modos Pasivos
    case "Espera":
      document.getElementById("botonNuevo").removeAttribute("disabled");
      document.getElementById("botonEditar").setAttribute("disabled", "true");
      document.getElementById("botonBorrar").setAttribute("disabled", "true");
      document.getElementById("botonAceptar").setAttribute("disabled", "true");
      document.getElementById("botonCancelar").setAttribute("disabled", "true");
      document.getElementById("textboxNombre").setAttribute("disabled","true");
      document.getElementById("menulistTipo").setAttribute("disabled","true");
      document.getElementById("textboxNotas").setAttribute("disabled","true");
      document.getElementById("botonMasApuntes").setAttribute("disabled","true");
      //Desactivamos los apuntes
      for (var i=0; i<maxApunte; i++){
  	idTextboxApunte = "textboxApunte" + i;
  	textboxApunte = document.getElementById(idTextboxApunte);
  	textboxApunte.setAttribute("disabled","true");
      }
      break;
    case "Consulta":
      document.getElementById("botonNuevo").removeAttribute("disabled");
      document.getElementById("botonEditar").removeAttribute("disabled");
      document.getElementById("botonBorrar").removeAttribute("disabled");
      document.getElementById("botonAceptar").setAttribute("disabled", "true");
      document.getElementById("botonCancelar").setAttribute("disabled", "true");
      document.getElementById("textboxNombre").setAttribute("disabled","true");
      document.getElementById("menulistTipo").setAttribute("disabled","true");
      document.getElementById("textboxNotas").setAttribute("disabled","true");
      document.getElementById("botonMasApuntes").setAttribute("disabled","true");
      //Desctivamos los apuntes
      for (var i=0; i<maxApunte; i++){
  	idTextboxApunte = "textboxApunte" + i;
  	textboxApunte = document.getElementById(idTextboxApunte);
  	textboxApunte.setAttribute("disabled","true");
      }
      break;

    //Modos Activos
    case "Insercin":
    case "Edicin":
      document.getElementById("botonNuevo").setAttribute("disabled","true");
      document.getElementById("botonEditar").setAttribute("disabled", "true");
      document.getElementById("botonBorrar").setAttribute("disabled", "true");
      document.getElementById("botonAceptar").removeAttribute("disabled");
      document.getElementById("botonCancelar").removeAttribute("disabled");
      document.getElementById("textboxNombre").removeAttribute("disabled");
      document.getElementById("menulistTipo").removeAttribute("disabled");
      document.getElementById("textboxNotas").removeAttribute("disabled");
      document.getElementById("botonMasApuntes").removeAttribute("disabled");
      //Activamos los apuntes
      for (var i=0; i<maxApunte; i++){
  	idTextboxApunte = "textboxApunte" + i;
  	textboxApunte = document.getElementById(idTextboxApunte);
  	textboxApunte.removeAttribute("disabled");
      }
      break;
      
    default:
      alert("El estado " + estado + " es desconocido");
  }
}/*}}}*/

function borrarCampos(){/*{{{*/
//Borra el contenido de los campos del formulario de predefinido
  document.getElementById("textboxNombre").value="";
  document.getElementById("menulistTipo").selectedIndex = -1;
  document.getElementById("textboxNotas").value="";

  borrarApuntes();
}/*}}}*/

function mostrar(){/*{{{*/
//Muestra los datos del predefinido en el formulario
  listboxPredefinidos = document.getElementById("listboxPredefinidos");
  if (((estadoIU == "Espera") || (estadoIU == "Consulta")) && (listboxPredefinidos.selectedItem)) {
    cambiarEstado("Consulta");
    predefinidoSeleccionado = listboxPredefinidos.selectedItem.predefinido;
    borrarApuntes(); 
    for(var i=0;i<predefinidoSeleccionado.apunte.length;i++)
      mostrarApunte(predefinidoSeleccionado.apunte[i]);    

    document.getElementById("textboxNombre").value = predefinidoSeleccionado.nombre;
    document.getElementById("menulistTipo").selectedItem = document.getElementById("menulistTipo").getElementsByAttribute("label", predefinidoSeleccionado.tipo.nombre)[0];
    document.getElementById("textboxNotas").value = predefinidoSeleccionado.notas;
  }
}/*}}}*/

function comprobarPredefinido(){/*{{{*/
//Comprueba la correccin de los datos del formulario
  //Nada que comprobar

  return true;
}/*}}}*/

function botonMasApuntes(){/*{{{*/
//Crea nuevas lneas de Apuntes
  for (var i=0; i<5; i++)
    crearApunte(false); //Crea apuntes con el campo de frmula habilitado
}/*}}}*/

function crearApunte(deshabilitado){/*{{{*/
//Crea una nueva lnea de Apunte
  var boxApunte = document.createElement("hbox");
  var idBoxApunte = "boxApunte" + maxApunte;
  boxApunte.setAttribute("id", idBoxApunte);
  var labelIndice = document.createElement("label");
  labelIndice.setAttribute("value", maxApunte);
  var labelApunte = document.createElement("label");
  idLabelApunte = "labelApunte" + maxApunte;
  labelApunte.setAttribute("id", idLabelApunte);
  labelApunte.setAttribute("value", "Arrastra Cuenta");
  labelApunte.setAttribute("style","background-color:lightsteelblue; border-style:inset; border-width:1px; min-width:100px; max-width:150px;");
  labelApunte.setAttribute("ondragdrop","nsDragAndDrop.drop(event, observerCuenta);");
  labelApunte.setAttribute("ondragover","nsDragAndDrop.dragOver(event, observerCuenta);");
  var textboxApunte = document.createElement("textbox");
  idTextboxApunte = "textboxApunte" + maxApunte;
  textboxApunte.setAttribute("id", idTextboxApunte);
  //textboxApunte.setAttribute("style", "text-align: right;");
  if (deshabilitado) textboxApunte.setAttribute("disabled", "true");
  textboxApunte.setAttribute("size", "10");

  boxApunte.appendChild(labelIndice);
  boxApunte.appendChild(labelApunte);
  boxApunte.appendChild(textboxApunte);
  document.getElementById("boxApuntes").appendChild(boxApunte);
  
  return maxApunte++;  
}/*}}}*/

function borrarApuntes(){/*{{{*/ 
//Borra los apuntes
    boxApuntes = document.getElementById("boxApuntes");
    while(boxApuntes.childNodes.length)
      boxApuntes.removeChild(boxApuntes.childNodes.item(0));
    maxApunte = 0;
}/*}}}*/

function mostrarApunte(apunte){/*{{{*/
//Crea un apunte y muestra en l sus datos
  indice = crearApunte(true); //Crea apuntes con el campo de frmular deshabilitado
  idLabelApunte = "labelApunte" + indice;
  idTextboxApunte = "textboxApunte" + indice;
  labelApunte = document.getElementById(idLabelApunte);
  textboxApunte = document.getElementById(idTextboxApunte);
  labelApunte.idCuenta = apunte.idCuenta;
  labelApunte.cuenta = contabilidad.verCuentaPorId(apunte.idCuenta);
  labelApunte.value = labelApunte.cuenta.nombre;
  labelApunte.setAttribute("tooltiptext", labelApunte.cuenta.verNombreCompleto());
  textboxApunte.value = apunte.formula;

}/*}}}*/


