// Variables Globales/*{{{*/
var contabilidad = parent.parent.contabilidad;
var cuentaSeleccionada;
var procesando = false;

var observerCuenta = {
  getSupportedFlavours : function () {
    var flavours = new FlavourSet();
    flavours.appendFlavour("cuenta");
    return flavours;
  },
  onDragStart: function (evt, transferData, action){

    transferData.data=new TransferData();
    transferData.data.addDataForFlavour("cuenta", cuentaSeleccionada.id);
  }
};  //Ojo al ; que estamos dando valor a una variable/*}}}*/
/*}}}*/

function iniciar(){/*{{{*/
  verCuentas();
}/*}}}*/

function alSeleccionar(){/*{{{*/
  
  if (procesando) return;
  
  //Guardamos la cuenta Seleccionada
  treeCuentas = document.getElementById("treeCuentas");
  cuentaSeleccionada = treeCuentas.view.getItemAtIndex(treeCuentas.currentIndex).cuenta;
  //Llamamos a mostrar() en el tab de cuentas
  window.frames[1].mostrar();
  //alert(document.getElementById("tabboxPrincipal").selectedTab.getAttribute("id"));
}/*}}}*/

function eliminarArbol(){ //{{{
//Borra el rbol de cuentas 
  var treechildrenCuentas =document.getElementById("treechildrenCuentas");
  
  //Guardamos el estado del rbol
  //for (var list in treechildrenCuentas)
    //alert(list);
  for (var i=0; i<treechildrenCuentas.childNodes.length; i++)
    guardaEstado(treechildrenCuentas.childNodes[i]);

  
  while(treechildrenCuentas.hasChildNodes())
    treechildrenCuentas.removeChild(treechildrenCuentas.firstChild);
} //}}}

function guardaEstado(nodo){/*{{{*/
//Guarda la visibilidad de la cuenta del rbol
  if (nodo.nodeName == "treeitem"){
    if (nodo.cuenta.abierta == "nueva subcuenta") //Si se ha creado una nueva subcuenta, forzamos a que se muestre abierta
      nodo.cuenta.abierta = true;
    else
      nodo.cuenta.abierta = nodo.getAttribute("open");
    for (var i=0; i<nodo.childNodes.length; i++)
      if (nodo.childNodes[i].nodeName == "treechildren")
	for (var j=0; j<nodo.childNodes[i].childNodes.length; j++)
	  guardaEstado(nodo.childNodes[i].childNodes[j]);
  }
}/*}}}*/

function verCuentas(){ //{{{
//Carga el rbol de cuentas
  procesando = true;  //Evitamos selecciones ahora
  eliminarArbol();
  var treechildrenCuentas = document.getElementById("treechildrenCuentas");
  //Creamos el primer nodo (especial)
  var treeitemContabilidad = document.createElement("treeitem");
  treeitemContabilidad.cuenta = contabilidad;
  var row = document.createElement("treerow");
  var cellNombre = document.createElement("treecell");
  var nombre = contabilidad.empresa + " - " + contabilidad.referencia;
  if (!contabilidad.empresa) nombre = "Sin Definir";
  cellNombre.setAttribute("label", nombre);
  cellNombre.setAttribute("tooltiptext", nombre);
  var cellTipo = document.createElement("treecell");
  cellTipo.setAttribute("label","");
  //var cellPGC = document.createElement("treecell");
  //cellPGC.setAttribute("label","");
  treeitemContabilidad.setAttribute("container","true");
  treeitemContabilidad.setAttribute("open","true");
  row.appendChild(cellTipo);
  row.appendChild(cellNombre);
  //row.appendChild(cellPGC);
  treeitemContabilidad.appendChild(row);
  var treechildren = document.createElement("treechildren");
  for(var i=0;i<contabilidad.cuenta.length;i++)
      treechildren.appendChild(verTreeitem(contabilidad.cuenta[i]));
      //treechildrenCuentas.appendChild(verTreeitem(contabilidad.cuenta[i]));
  treeitemContabilidad.appendChild(treechildren);
  treechildrenCuentas.appendChild(treeitemContabilidad);
  procesando = false;
  
  /* Sin el primer nodo
  for(var i=0;i<contabilidad.cuenta.length;i++)
      treechildrenCuentas.appendChild(verTreeitem(contabilidad.cuenta[i]));
      //treechildrenCuentas.appendChild(verTreeitem(contabilidad.cuenta[i]));
  procesando = false;
  */
} //}}}

function verTreeitem(cuenta){  //{{{
  var item = document.createElement("treeitem");
  item.cuenta = cuenta;	  // Cada item del rbol tiene un atributo que es el puntero a la cuenta que representa
  item.setAttribute("open",cuenta.abierta); //De esta forma, se mantiene el rbol al crearse
  var row = document.createElement("treerow");
  var cellTipo = document.createElement("treecell");
  cellTipo.setAttribute("label", cuenta.tipo);
  var cellNombre = document.createElement("treecell");
  cellNombre.setAttribute("label", cuenta.nombre);
  cellNombre.setAttribute("tooltiptext", cuenta.nombre);
 // var cellPgc = document.createElement("treecell");
 // cellPgc.setAttribute("label",cuenta.pgc);
  //Estructura
  row.appendChild(cellTipo);
  row.appendChild(cellNombre);
  //row.appendChild(cellPgc);
  item.appendChild(row);
  if (cuenta.cuenta.length > 0){
    item.setAttribute("container","true");
    //item.setAttribute("open","false");
    var treechildren = document.createElement("treechildren");
    //Ordenamos alfabticamente sus subcuentas
    cuenta.cuenta.sort(ordenarCuentas);
    for (var i=0;i<cuenta.cuenta.length;i++)
      treechildren.appendChild(verTreeitem(cuenta.cuenta[i]));
    item.appendChild(treechildren);
  }
  return item;
} //}}}

function seleccionarCuenta(textbox){/*{{{*/
//Pone el nombre de la cuenta seleccionada en el textbox indicado
  textbox.value=cuentaSeleccionada.nombre;
  textbox.cuenta=cuentaSeleccionada;
}/*}}}*/

function ordenarCuentas(cuenta1, cuenta2){/*{{{*/
//Una sencilla funcin para ordenar las cuentas por su nombre
  if (cuenta1.nombre >= cuenta2.nombre) return 1;
  else return -1;
}/*}}}*/
